function [tree optMSE] = regress_tree_CV( X, Y, nFold )

n = size(X,1);

%index postive examples and negative examples
index = randperm(n);

for i = 1 : nFold
    trainFold{i} = index( [1 : round((i-1)*n/nFold), round((i)*n/nFold)+1 : n] );
    testFold{i} = index( round((i-1)*n/nFold)+1 : round((i)*n/nFold) );
    %disp(sprintf('size of Train fold %g: (%g, %g)', i, size(trainFold{i},1), size(trainFold{i},2)));
    %disp(sprintf('size of Test fold %g: (%g, %g)', i, size(testFold{i},1), size(testFold{i},2)));
end



error = 0;
for j = 1 : nFold
    tree = classregtree(X(trainFold{j},:), Y(trainFold{j},:), 'method', 'regression');
    testError = mean( ( eval(tree, X(testFold{j},:)) - Y(testFold{j},:) ).^2 );
    error = error + testError;
    %disp(sprintf('This fold has error: %g', tempE));
end
optMSE = error/nFold;
disp(sprintf('Finally, tree regression error averaged as %g', optMSE));

tree = classregtree(X, Y, 'method', 'regression');

